%global pypi_name cryptography

%bcond_without check

Name:           python-%{pypi_name}
Version:        39.0.1
%define subrel 1
Release:        %mkrel 1
Summary:        PyCA's cryptography library
Group:          Development/Python
License:        ASL 2.0 or BSD
URL:            https://cryptography.io/en/latest/
Source0:        https://github.com/pyca/cryptography/archive/%{version}/%{pypi_name}-%{version}.tar.gz
# Backported patches from upstream main branch
Patch0002:	0002-more-release.py-fixes-and-improvements-7956.patch
Patch0004:	0004-Last-step-in-deprecating-3.6-7961.patch
Patch0006:	0006-small-refactor-in-ssh-for-key-type-7983.patch
Patch0007:	0007-move-ssh-tests-to-a-new-file-7982.patch
Patch0008:	0008-add-ssh-certificate-test-vectors-7984.patch
Patch0009:	0009-another-ssh-cert-vector-7991.patch
Patch0010:	0010-more-test-vectors-for-ssh-certs-7993.patch
Patch0011:	0011-more-SSH-tests-moved-to-test_ssh-8001.patch
Patch0012:	0012-support-SSH-certificate-parsing-7960.patch
Patch0013:	0013-Use-the-more-modern-OpenSSL-incantation-in-tests-800.patch
Patch0014:	0014-SSHCertificateBuilder-8004.patch
Patch0015:	0015-UNIX-is-a-trademark-Unix-is-a-category-8008.patch
Patch0016:	0016-switch-to-using-integers-for-valid_after-valid_befor.patch
Patch0017:	0017-deprecate-support-for-DSA-in-load_ssh_public_key-800.patch
Patch0018:	0018-more-rigorously-document-that-our-verify-methods-ret.patch
Patch0019:	0019-deprecate-the-rest-of-DSA-support-for-SSH-8013.patch
Patch0020:	0020-Bump-cxx-from-1.0.85-to-1.0.86-in-src-rust-8016.patch
Patch0021:	0021-Bump-cxx-build-from-1.0.85-to-1.0.86-in-src-rust-801.patch
Patch0022:	0022-remove-the-last-vestiges-of-sha1-out-of-pkcs7-8032.patch
Patch0023:	0023-mismatched-inner-outer-signature-algorithm-x509-cert.patch
Patch0024:	0024-Bump-pem-from-1.1.0-to-1.1.1-in-src-rust-8043.patch
Patch0025:	0025-fixes-8035-added-a-test-for-loading-a-cert-with-anot.patch
Patch0026:	0026-Add-Certificate.verify_signed_by-8011.patch
Patch0027:	0027-fix-a-math-mistake-in-a-comment-8046.patch
Patch0028:	0028-serial_number-is-not-a-function-8061.patch
Patch0029:	0029-fixes-8052-correct-NameAttribute.value-documentation.patch
Patch0030:	0030-Update-installation.rst-8067.patch
Patch0031:	0031-Bump-termcolor-from-1.1.3-to-1.2.0-in-src-rust-8070.patch
Patch0032:	0032-rename-variable-to-make-sense-8080.patch
Patch0033:	0033-Bump-proc-macro2-from-1.0.49-to-1.0.50-in-src-rust-8.patch
Patch0035:	0035-Remove-CircleCI-8092.patch
Patch0036:	0036-test-on-jammy-arm64-and-not-focal-8101.patch
Patch0037:	0037-Use-the-ruff-pyupgrade-checks-8104.patch
Patch0038:	0038-Style-fixes-for-latest-ruff-8120.patch
Patch0039:	0039-Remove-repeated-hex-conversion-of-tag-in-AES-GCM-tes.patch
Patch0040:	0040-fix-for-a-future-warning-8146.patch
Patch0041:	0041-make-tox-verbose-on-install-again-for-tox4-8155.patch
Patch0042:	0042-Bump-cc-from-1.0.78-to-1.0.79-in-src-rust-8157.patch
Patch0043:	0043-Use-Rust-for-CSR-is_signature_valid-8161.patch
Patch0044:	0044-add-CRL-vector-with-an-inner-outer-signature-OID-mis.patch
Patch0045:	0045-Use-Rust-for-CRL-is_signature_valid-8162.patch
Patch0046:	0046-Several-cleanups-to-the-backend-8166.patch
Patch0047:	0047-pass-CARGO_REGISTRIES_CRATES_IO_PROTOCOL-through-tox.patch
Patch0048:	0048-update-our-security-reporting-instructions-8171.patch
Patch0049:	0049-fix-CI-with-tox-4.4.4-8184.patch
Patch0050:	0050-Update-style-for-new-black-8185.patch
Patch0051:	0051-Bump-js-sys-from-0.3.60-to-0.3.61-in-src-rust-8191.patch
Patch0052:	0052-add-support-for-bytes-like-objects-in-data-and-assoc.patch
Patch0053:	0053-don-t-run-dsa-wycheproof-without-dsa-8201.patch
Patch0054:	0054-document-that-inheritance-is-not-the-way-8204.patch
Patch0055:	0055-Specify-rust-version-for-clippy-8206.patch
Patch0056:	0056-Bump-proc-macro2-from-1.0.50-to-1.0.51-in-src-rust-8.patch
Patch0057:	0057-add-support-for-centos9-fips-8216.patch
Patch0058:	0058-ignore-a-new-ruff-warning-type-8225.patch
Patch0060:	0060-use-the-modern-invocation-for-our-sphinx-rtd-theme-8.patch
Patch0061:	0061-fix-some-pytest-warnings-8245.patch
Patch0062:	0062-Remove-redundant-ruff-excludes-8256.patch
Patch0063:	0063-remove-verify_interface-8260.patch
Patch0064:	0064-Simplify-X25519-key-loading-8263.patch
Patch0065:	0065-Remove-now-unused-bindings-8264.patch
Patch0066:	0066-Added-type-annotations-for-more-things-in-backend-82.patch
Patch0067:	0067-Disallow-wildcards-in-DNSName-for-name-constraints-8.patch
Patch0068:	0068-fix-some-binding-declarations-8273.patch
Patch0069:	0069-Bump-cxx-build-from-1.0.86-to-1.0.90-in-src-rust-827.patch
Patch0070:	0070-Bump-cxx-from-1.0.86-to-1.0.90-in-src-rust-8276.patch
Patch0071:	0071-fix-a-warning-in-C-code-via-explicit-cast-8280.patch
Patch0072:	0072-fixes-8284-include-tox.ini-in-the-sdist-8285.patch
Patch0073:	0073-try-to-resolve-two-compilation-warnings-8286.patch
Patch0074:	0074-update-to-latest-pytest-subtests-and-add-the-new-fla.patch
Patch0075:	0075-Bump-cxx-from-1.0.90-to-1.0.91-in-src-rust-8309.patch
Patch0076:	0076-Bump-ouroboros-from-0.15.5-to-0.15.6-in-src-rust-831.patch
Patch0077:	0077-remove-two-bindings-functions-that-were-unused-8304.patch
Patch0078:	0078-remove-unused-typedefs-8305.patch
Patch0079:	0079-Bump-cxx-build-from-1.0.90-to-1.0.91-in-src-rust-830.patch
Patch0080:	0080-fixes-8316-correct-docstring-8318.patch
Patch0081:	0081-fixes-8316-correct-docstring-8319.patch
Patch0082:	0082-Remove-unused-bindings-8321.patch
Patch0083:	0083-remove-unused-ssl-bindings-8323.patch
Patch0084:	0084-remove-unused-x509-bindings-8324.patch
Patch0085:	0085-remove-unused-x509name-bindings-8325.patch
Patch0086:	0086-remove-verification-error-code-bindings-8326.patch
Patch0087:	0087-remove-unused-bio-bindings-8322.patch
Patch0088:	0088-remove-unused-pkcs7-binding-8327.patch
Patch0089:	0089-remove-series-of-unused-Cryptography_HAS-bindings-83.patch
Patch0090:	0090-remove-unused-CRL-bindings-8333.patch
Patch0091:	0091-remove-unused-pkcs7-bindings-8332.patch
Patch0092:	0092-remove-unused-evp-binding-8331.patch
Patch0093:	0093-remove-unused-netscape-spki-binding-8330.patch
Patch0094:	0094-remove-unused-ec-bindings-8329.patch
Patch0095:	0095-remove-some-error-bindings-8334.patch
Patch0096:	0096-remove-unused-constant-8335.patch
Patch0097:	0097-remove-unused-x509-binding-8336.patch
Patch0098:	0098-remove-unused-DTLS-bindings-8337.patch
Patch0099:	0099-remove-SSL_sess-bindings-8338.patch
Patch0100:	0100-remove-some-reneg-bindings-8339.patch
Patch0101:	0101-remove-SSL_CIPHER-bindings-8341.patch
Patch0102:	0102-remove-proto_version-getters-and-most-SSL_SESSION_-b.patch
Patch0103:	0103-Remove-unused-rsa-binding-8345.patch
Patch0104:	0104-remove-unused-object-binding-8344.patch
Patch0105:	0105-remove-unused-ssl-binding-8346.patch
Patch0106:	0106-remove-unused-x509-name-binding-8348.patch
Patch0107:	0107-remove-unused-ssl-bindings-8353.patch
Patch0108:	0108-remove-unused-x509-bindings-8343.patch
Patch0109:	0109-remove-unused-x509-verify-bindings-8347.patch
Patch0110:	0110-remove-unused-ssl-binding-8354.patch
Patch0111:	0111-remove-unused-error-binding-8355.patch
Patch0112:	0112-remove-unused-x509-verify-bindings-8356.patch
Patch0113:	0113-remove-unused-x509-verify-bindings-8358.patch
Patch0114:	0114-remove-more-unused-ssl-bindings-8359.patch
Patch0115:	0115-endless-binding-removal-8360.patch
Patch0116:	0116-embrace-my-inner-nitpicker-8361.patch
Patch0117:	0117-Fix-SSHCertificateBuilder-sample-code-8373.patch
Patch0118:	0118-Add-shortcut-methods-for-exporting-EC-keys-as-raw-by.patch
Patch0119:	0119-fixes-8374-removed-docs-for-removed-method-8377.patch
Patch0120:	0120-Enforce-max-number-of-SSH-certificate-principals-837.patch
Patch0121:	0121-Bump-syn-from-1.0.107-to-1.0.108-in-src-rust-8383.patch
Patch0122:	0122-Bump-syn-from-1.0.108-to-1.0.109-in-src-rust-8385.patch
# Upgrade to pyo3 0.18
# https://github.com/pyca/cryptography/pull/6935
Patch0501:	0001-Upgrade-to-pyo3-0.16.patch
Patch0502:	0002-Upgrade-to-pyo3-0.17.patch
Patch0503:	0003-Upgrade-to-pyo3-0.18.patch
# Security patches
# CVE-2023-49083
Patch0600:	66cb448876b1e95b637461d13560b970bae09e08.patch
Patch0601:	CVE-2024-26130.patch
# Mageia patches
Patch1001:	0001-Make-urpmi-and-Mageia-BS-happy.patch
BuildRequires:  openssl-devel >= 3.0.15-1.3
BuildRequires:  gcc
BuildRequires:  gnupg2
BuildRequires:  git-core
BuildRequires:  rust-packaging
BuildRequires:  pyproject-rpm-macros
BuildRequires:  python3-devel

%description
cryptography is a package designed to expose cryptographic primitives and
recipes to Python developers.

%package -n  python3-%{pypi_name}
Group:          Development/Python
Summary:        PyCA's cryptography library
%{?python_provide:%python_provide python3-%{pypi_name}}


%description -n python3-%{pypi_name}
cryptography is a package designed to expose cryptographic primitives and
recipes to Python developers.

%prep
%autosetup -p1 -n %{pypi_name}-%{version} -Sgit_am

%generate_buildrequires
%pyproject_buildrequires -x test
# use cargo macros to make use of RPMified crates
%cargo_prep
cd src/rust
rm -f Cargo.lock
%cargo_generate_buildrequires
cd ../..

%build
%pyproject_wheel

%install
# Actually other *.c and *.h are appropriate
# see https://github.com/pyca/cryptography/issues/1463
find . -name .keep -print -delete
%pyproject_install
%pyproject_save_files %{pypi_name}

%check
%if %{with check}
# see https://github.com/pyca/cryptography/issues/4885 and
# see https://bugzilla.redhat.com/show_bug.cgi?id=1761194 for deselected tests
# see rhbz#2042413 for memleak. It's unstable under Python 3.11 and makes
# not much sense for downstream testing.
PYTHONPATH=${PWD}/vectors:%{buildroot}%{python3_sitearch} \
    %{__python3} -m pytest \
    -k "not (test_buffer_protocol_alternate_modes or test_dh_parameters_supported or test_load_ecdsa_no_named_curve or test_openssl_memleak or test_load_with_other_sections)"
%endif

%files -n python3-%{pypi_name} -f %{pyproject_files}
%doc README.rst docs
%license LICENSE*


%changelog
* Fri Feb 14 2025 ns80 <ns80> 39.0.1-1.1.mga9
+ Revision: 2148818
- rebuild with openssl-3.0.15-1.3.mga9 for CVE-2023-50782 (mga#32584)
- add patch from Ubuntu for CVE-2024-26130 (mga#32584)
- add patch from upstream CVE-2023-49083 (mga#32584)

* Sat Feb 25 2023 wally <wally> 39.0.1-1.mga9
+ Revision: 1945366
- new version 39.0.1
- backport patches from upstream main branch and pyo3 0.18 update pull request

* Sun Jan 15 2023 wally <wally> 39.0.0-1.mga9
+ Revision: 1933467
- new version 39.0.0

* Thu Nov 24 2022 papoteur <papoteur> 38.0.3-1.mga9
+ Revision: 1910835
- new 38.0.3

* Mon Nov 14 2022 guillomovitch <guillomovitch> 37.0.4-1.mga9
+ Revision: 1907287
- new version 37.0.4
+ kekepower <kekepower>
- Update to version 38.0.3

* Tue Apr 12 2022 guillomovitch <guillomovitch> 36.0.1-3.mga9
+ Revision: 1849174
- use packaged rust build dependencies

* Wed Mar 30 2022 umeabot <umeabot> 36.0.1-2.mga9
+ Revision: 1834350
- Mageia 9 Mass Rebuild

* Sun Feb 13 2022 wally <wally> 36.0.1-1.mga9
+ Revision: 1773721
- build using vendored rust crates
- sync with Fedora where appropriate
- new version 36.0.1
- rebuild for python3.10
- rebuild for openssl 3.0.0

* Sat Aug 28 2021 wally <wally> 3.4.8-1.mga9
+ Revision: 1743125
- new version 3.4.8

* Sat Mar 20 2021 wally <wally> 3.4.6-1.mga9
+ Revision: 1705768
- skip rust build for now
+ tv <tv>
- rebuild for python-3.9.2
+ neoclust <neoclust>
- Rebuild against python 3.9
- New version 3.4.6
- New version 3.3.2: Fixes CVE-2020-36242 (mga#28384)

* Sun Dec 13 2020 guillomovitch <guillomovitch> 3.3.1-1.mga8
+ Revision: 1656427
- new version 3.3.1

* Sun Nov 01 2020 guillomovitch <guillomovitch> 3.2.1-1.mga8
+ Revision: 1641466
- new version 3.2.1

* Sat Sep 05 2020 guillomovitch <guillomovitch> 3.1-1.mga8
+ Revision: 1622539
- new version 3.1

* Thu Jul 16 2020 wally <wally> 2.9.2-2.mga8
+ Revision: 1606570
- add patch to drop boolean deps from generated requires

* Tue Jul 14 2020 guillomovitch <guillomovitch> 2.9.2-1.mga8
+ Revision: 1605987
- new version 2.9.2

* Thu Mar 05 2020 kekepower <kekepower> 2.8-1.mga8
+ Revision: 1554161
- Update to version 2.8

* Sun Feb 16 2020 umeabot <umeabot> 2.7-3.mga8
+ Revision: 1530733
- Mageia 8 Mass Rebuild

* Wed Sep 04 2019 wally <wally> 2.7-2.mga8
+ Revision: 1437365
- rebuild for python3.8
- drop python2 support

* Sat Aug 10 2019 shlomif <shlomif> 2.7-1.mga8
+ Revision: 1428499
- New version 2.7

* Wed Apr 17 2019 wally <wally> 2.6.1-1.mga7
+ Revision: 1392288
- new version 2.6.1

* Mon Jan 14 2019 luigiwalser <luigiwalser> 2.4.2-1.mga7
+ Revision: 1356243
- 2.4.2

* Sat Jan 05 2019 wally <wally> 2.4.1-3.mga7
+ Revision: 1349622
- rebuild for python3.7 without tests

* Tue Jan 01 2019 wally <wally> 2.4.1-2.mga7
+ Revision: 1348079
- build with tests

* Mon Dec 31 2018 luigiwalser <luigiwalser> 2.4.1-1.mga7
+ Revision: 1347714
- disable check for now as newer pytest is required
- 2.4.1

* Wed Oct 24 2018 bcornec <bcornec> 2.3.1-1.mga7
+ Revision: 1325064
- update to upstream python-cryptography 2.3.1

* Sun Sep 23 2018 umeabot <umeabot> 2.2.2-3.mga7
+ Revision: 1300463
- Mageia 7 Mass Rebuild

* Wed Jul 25 2018 daviddavid <daviddavid> 2.2.2-2.mga7
+ Revision: 1245162
- remove some hard requires that are already auto-required

* Fri Apr 20 2018 kekepower <kekepower> 2.2.2-1.mga7
+ Revision: 1220456
- Update to version 2.2.2
- Use python_provide

* Thu Jan 04 2018 guillomovitch <guillomovitch> 2.1.4-1.mga7
+ Revision: 1190122
- new version 2.1.4
- new version 2.1.4

* Thu Oct 05 2017 tv <tv> 2.0.3-4.mga7
+ Revision: 1169083
- add BR on python2dist(asn1crypto) thus fixing build

* Sun Aug 06 2017 neoclust <neoclust> 2.0.3-3.mga7
+ Revision: 1137753
- Add missing provide

* Sun Aug 06 2017 joequant <joequant> 2.0.3-2.mga7
+ Revision: 1137541
- convert to new conventions python

* Sat Aug 05 2017 philippem <philippem> 2.0.3-1.mga7
+ Revision: 1135143
- update to 2.0.3, rebuild for Python 3.6

* Fri Nov 11 2016 philippem <philippem> 1.5.3-1.mga6
+ Revision: 1066348
- update to 1.5.3, fix CVE-2016-9243 mga#19736

* Fri Oct 28 2016 philippem <philippem> 1.5.2-1.mga6
+ Revision: 1063822
- add BR on pytz
- update to 1.5.2

* Tue May 17 2016 philippem <philippem> 1.3.2-1.mga6
+ Revision: 1016543
- update to 1.3.2

* Sun Apr 10 2016 philippem <philippem> 1.3.1-1.mga6
+ Revision: 1000033
- update to 1.3.1

* Sat Mar 05 2016 philippem <philippem> 1.2.3-1.mga6
+ Revision: 986120
- update to 1.2.3
- update to 1.2.3
+ umeabot <umeabot>
- Rebuild for openssl

* Sat Feb 13 2016 philippem <philippem> 1.2.2-1.mga6
+ Revision: 959785
- update to 1.2.2

* Fri Dec 04 2015 philippem <philippem> 1.1.1-1.mga6
+ Revision: 908237
- add BR for tests, disable python3 tests
- update to 1.1.1

* Thu Oct 29 2015 philippem <philippem> 1.1-1.mga6
+ Revision: 896476
- update to 1.1

* Sun Oct 11 2015 philippem <philippem> 1.0.2-1.mga6
+ Revision: 889682
- update to 1.0.2

* Thu Oct 08 2015 tv <tv> 1.0.1-2.mga6
+ Revision: 887747
- rebuild for python 3.5

* Thu Sep 24 2015 philippem <philippem> 1.0.1-1.mga6
+ Revision: 883390
- update to 1.0.1

* Sun Mar 08 2015 philippem <philippem> 0.7.2-1.mga5
+ Revision: 818107
- imported package python-cryptography

